package CS561A2.Farris;

import java.io.*;
import java.util.ArrayList;

public class puzzle {

	//List of All n-queen solutions
	public static ArrayList<int[]> solutions = new ArrayList<int[]>();
	
	
	//Write solutions to file specified in arg[1]
	public static void Write(int N, String outFile) {
		int numSolutions = 1;
		try { 
			BufferedWriter out = new BufferedWriter(new FileWriter(outFile));

			out.write("Number of Queens: " + N);
			out.newLine();
			
			for(int k=0; k<solutions.size(); k++) {
				out.write("Solution " + numSolutions + ": ");
				int[] col = (int[]) solutions.get(k);
				for(int i=0; i<col.length; i++) {
					//System.out.println(col[i]);
					for(int j=0; j<col.length; j++) {
						if(col[i] == j) {
							out.write("("+(i+1)+","+(j+1)+"), ");
						}
					}
				}
				out.newLine();
				numSolutions++;
			}
			if(numSolutions-1 == -1) {
				numSolutions = 0;
			}
			out.write("Total Number of Solutions: " + (numSolutions-1));
			out.close();
		}catch (IOException e) {
			System.out.println("Error writing output file");
			System.exit(0);
		}
	}
	
	//Check to make sure the placed Queen isn't in the same
	//Column, Row, or Diagonal as another Queen
	public static boolean IsCorrect(int[] col, int num) {
		for(int i=0; i<num; i++) {
			
			//Check for same column
			if(col[i] == col[num]) {
				return false;
			}
			//Check if Diagonal Below
			if(col[num] -col[i] == (num-i)) {
				return false;
			}
			//Check Diagonal Above
			if(col[i]-col[num] == (num-i)) {
				return false;
			}
			
		}
		
		return true;
	}
	
		
	//Get all Solutions using Backtracking
	public static void RecursiveSolve(int[] col, int num) {
		int queensPlaced = col.length;
		
		//If all the Queens are placed, we add the solution to the list
		//of solutions found.
		if(queensPlaced == num) {	
			int[] newCol = col.clone();
			solutions.add(newCol);
		}
		else {
			for(int i=0; i<queensPlaced; i++) {
				col[num] = i;
				if(IsCorrect(col,num) == true) {
					RecursiveSolve(col,num+1);
				}
			}
		}
		
	}
	
	public static void main(String[] args) {
		
		//Variables are the N number of Queens
		//Domain is the columns on the board
		//Constraint is that a Queen cannot be in the same row/column/diagonal of another Queen
		int n = 0;
		
		//Get size of board and number of Queens from input
		try {
			n = Integer.parseInt(args[0]);
		} catch(NumberFormatException e) {
			System.out.println("Incorrect type for N" + e.getMessage());
			System.exit(0);
		}
		
		int[] col = new int[n];
		String outFile = args[1];
		
		//Solve the puzzle and write all the solutions to output file
		RecursiveSolve(col,0);
		Write(n,outFile);
		
		
	}

}
